/**
 * name: @tresjs/post-processing
 * version: v0.3.0
 * (c) 2023
 * description: Post-processing library for TresJS
 * author: Alvaro Saburido <hola@alvarosaburido.dev> (https://github.com/alvarosabu/)
 */
import { inject as C, getCurrentInstance as k, onMounted as I, nextTick as q, getCurrentScope as J, onScopeDispose as Q, unref as D, ref as b, watch as p, computed as y, defineComponent as O, shallowRef as T, provide as Z, watchEffect as P, renderSlot as _, toRaw as S, onUnmounted as F } from "vue";
import { HalfFloatType as ee } from "three";
import { useTres as te, useRenderLoop as ne, normalizeColor as R } from "@tresjs/core";
import { EffectComposer as ae, RenderPass as le, NormalPass as ue, DepthDownsamplingPass as oe, BlendFunction as W, BloomEffect as ie, EffectPass as L, GlitchMode as j, GlitchEffect as re, OutlineEffect as G } from "postprocessing";
function A() {
  const { state: e, setState: a } = C("useTres", te()), n = C("extend") || (() => {
  });
  return {
    state: e,
    setState: a,
    extend: n
  };
}
let w;
function se() {
  var e;
  if (w !== void 0)
    return w;
  try {
    let a;
    const n = document.createElement("canvas");
    return w = !!(window.WebGL2RenderingContext && (a = n.getContext("webgl2"))), a && ((e = a.getExtension("WEBGL_lose_context")) == null || e.loseContext()), w;
  } catch {
    return w = !1;
  }
}
function N(e) {
  return J() ? (Q(e), !0) : !1;
}
function H(e) {
  return typeof e == "function" ? e() : D(e);
}
const ce = typeof window < "u", de = () => {
};
function fe(e, a = !0) {
  k() ? I(e) : a ? e() : q(e);
}
function E(e) {
  var a;
  const n = H(e);
  return (a = n == null ? void 0 : n.$el) != null ? a : n;
}
const X = ce ? window : void 0;
function M(...e) {
  let a, n, t, l;
  if (typeof e[0] == "string" || Array.isArray(e[0]) ? ([n, t, l] = e, a = X) : [a, n, t, l] = e, !a)
    return de;
  Array.isArray(n) || (n = [n]), Array.isArray(t) || (t = [t]);
  const r = [], c = () => {
    r.forEach((i) => i()), r.length = 0;
  }, f = (i, o, s, d) => (i.addEventListener(o, s, d), () => i.removeEventListener(o, s, d)), v = p(
    () => [E(a), H(l)],
    ([i, o]) => {
      c(), i && r.push(
        ...n.flatMap((s) => t.map((d) => f(i, s, d, o)))
      );
    },
    { immediate: !0, flush: "post" }
  ), u = () => {
    v(), c();
  };
  return N(u), u;
}
function ve() {
  const e = b(!1);
  return k() && I(() => {
    e.value = !0;
  }), e;
}
function me(e) {
  const a = ve();
  return y(() => (a.value, !!e()));
}
var $ = Object.getOwnPropertySymbols, he = Object.prototype.hasOwnProperty, be = Object.prototype.propertyIsEnumerable, ge = (e, a) => {
  var n = {};
  for (var t in e)
    he.call(e, t) && a.indexOf(t) < 0 && (n[t] = e[t]);
  if (e != null && $)
    for (var t of $(e))
      a.indexOf(t) < 0 && be.call(e, t) && (n[t] = e[t]);
  return n;
};
function Se(e, a, n = {}) {
  const t = n, { window: l = X } = t, r = ge(t, ["window"]);
  let c;
  const f = me(() => l && "ResizeObserver" in l), v = () => {
    c && (c.disconnect(), c = void 0);
  }, u = y(
    () => Array.isArray(e) ? e.map((s) => E(s)) : [E(e)]
  ), i = p(
    u,
    (s) => {
      if (v(), f.value && l) {
        c = new ResizeObserver(a);
        for (const d of s)
          d && c.observe(d, r);
      }
    },
    { immediate: !0, flush: "post", deep: !0 }
  ), o = () => {
    v(), i();
  };
  return N(o), {
    isSupported: f,
    stop: o
  };
}
function pe(e, a = {}) {
  const {
    reset: n = !0,
    windowResize: t = !0,
    windowScroll: l = !0,
    immediate: r = !0
  } = a, c = b(0), f = b(0), v = b(0), u = b(0), i = b(0), o = b(0), s = b(0), d = b(0);
  function m() {
    const g = E(e);
    if (!g) {
      n && (c.value = 0, f.value = 0, v.value = 0, u.value = 0, i.value = 0, o.value = 0, s.value = 0, d.value = 0);
      return;
    }
    const h = g.getBoundingClientRect();
    c.value = h.height, f.value = h.bottom, v.value = h.left, u.value = h.right, i.value = h.top, o.value = h.width, s.value = h.x, d.value = h.y;
  }
  return Se(e, m), p(() => E(e), (g) => !g && m()), l && M("scroll", m, { capture: !0, passive: !0 }), t && M("resize", m, { passive: !0 }), fe(() => {
    r && m();
  }), {
    height: c,
    bottom: f,
    left: v,
    right: u,
    top: i,
    width: o,
    x: s,
    y: d,
    update: m
  };
}
const z = Symbol(), Ee = /* @__PURE__ */ O({
  __name: "EffectComposer",
  props: {
    enabled: { type: Boolean, default: !0 },
    children: {},
    depthBuffer: { type: Boolean },
    disableNormalPass: { type: Boolean, default: !1 },
    stencilBuffer: { type: Boolean },
    resolutionScale: {},
    autoClear: { type: Boolean, default: !0 },
    multisampling: { default: 8 },
    frameBufferType: { default: () => ee },
    scene: {},
    camera: {}
  },
  setup(e) {
    const { state: a } = A(), n = T(null), t = y(() => e.scene || a.scene), l = y(() => e.camera || a.camera);
    let r = null, c = null;
    const f = se();
    Z(z, n);
    function v() {
      n.value && (c = new ue(t.value, l.value), c.enabled = !1, n.value.addPass(c), e.resolutionScale !== void 0 && f && (r = new oe({
        normalBuffer: c.texture,
        resolutionScale: e.resolutionScale
      }), r.enabled = !1, n.value.addPass(r)));
    }
    const u = y(() => {
      var d;
      return (d = a.canvas) == null ? void 0 : d.value;
    }), { width: i, height: o } = pe(u);
    P(() => {
      n.value && i.value && o.value && n.value.setSize(i.value, o.value);
    }), P(() => {
      a.renderer && t.value && l.value && (n.value = new ae(a.renderer, {
        depthBuffer: e.depthBuffer,
        stencilBuffer: e.stencilBuffer,
        multisampling: e.multisampling > 0 && f ? e.multisampling : 0,
        frameBufferType: e.frameBufferType
      }), n.value.addPass(new le(t.value, l.value)), e.disableNormalPass || v());
    });
    const { onLoop: s } = ne();
    return s(({ delta: d }) => {
      if (e.enabled && a.renderer && n.value && i.value && o.value) {
        const m = a.renderer.autoClear;
        a.renderer.autoClear = e.autoClear, e.stencilBuffer && !e.autoClear && a.renderer.clearStencil(), n.value.render(d), a.renderer.autoClear = m;
      }
    }), (d, m) => _(d.$slots, "default");
  }
}), Be = /* @__PURE__ */ O({
  __name: "Bloom",
  props: {
    blendFunction: { default: () => W.ADD },
    intensity: { default: 1 },
    blurPass: {},
    width: {},
    height: {},
    kernelSize: {},
    luminanceThreshold: { default: 0.9 },
    luminanceSmoothing: { default: 0.025 },
    mipmapBlur: { type: Boolean, default: !1 }
  },
  setup(e, { expose: a }) {
    const { state: n } = A(), t = C(z), l = b(null), r = b(null);
    a({ pass: l, effect: r });
    function c() {
      r.value = new ie({
        blendFunction: e.blendFunction,
        mipmapBlur: e.mipmapBlur,
        intensity: e.intensity,
        luminanceThreshold: e.luminanceThreshold,
        luminanceSmoothing: e.luminanceSmoothing
      }), l.value = new L(D(n.camera), S(r.value));
    }
    function f() {
      var i, o, s;
      (i = r.value) == null || i.dispose(), (o = l.value) == null || o.dispose(), (s = t == null ? void 0 : t.value) == null || s.removePass(S(l.value));
    }
    const v = p(
      () => [n.camera, t == null ? void 0 : t.value],
      () => {
        var i;
        n.camera && t && t.value && (c(), (i = t == null ? void 0 : t.value) == null || i.addPass(S(l.value)));
      }
    ), u = p(
      () => [e.blendFunction, e.mipmapBlur, e.intensity, e.luminanceThreshold, e.luminanceSmoothing],
      () => {
        var i;
        l.value && (f(), c(), (i = t == null ? void 0 : t.value) == null || i.addPass(S(l.value)));
      }
    );
    return F(() => {
      f(), v(), u();
    }), (i, o) => null;
  }
}), xe = /* @__PURE__ */ O({
  __name: "Glitch",
  props: {
    blendFunction: { default: () => W.ADD },
    delay: {},
    duration: {},
    strength: {},
    mode: {},
    active: { type: Boolean },
    ratio: { default: 0.85 },
    columns: { default: 0.05 },
    chromaticAberrationOffset: {},
    peturbationMap: {},
    dtSize: { default: 64 }
  },
  setup(e, { expose: a }) {
    const { state: n } = A(), t = C(z), l = b(null), r = b(null);
    a({ pass: l });
    function c() {
      r.value = new re({
        blendFunction: e.blendFunction,
        delay: e.delay,
        duration: e.duration,
        strength: e.strength,
        ratio: e.ratio,
        columns: e.columns,
        chromaticAberrationOffset: e.chromaticAberrationOffset,
        dtSize: e.dtSize
      }), l.value = new L(D(n.camera), S(r.value));
    }
    function f() {
      var o, s, d;
      (o = r.value) == null || o.dispose(), (s = l.value) == null || s.dispose(), (d = t == null ? void 0 : t.value) == null || d.removePass(S(l.value));
    }
    const v = p(
      () => [n.camera, t == null ? void 0 : t.value],
      () => {
        var o;
        n.camera && t && t.value && (c(), (o = t == null ? void 0 : t.value) == null || o.addPass(S(l.value)));
      }
    ), u = p(
      () => [e.delay, e.duration, e.strength, e.ratio, e.columns, e.chromaticAberrationOffset, e.peturbationMap, e.dtSize],
      () => {
        var o, s;
        l.value && ((o = t == null ? void 0 : t.value) == null || o.removePass(S(l.value)), c(), (s = t == null ? void 0 : t.value) == null || s.addPass(S(l.value)));
      }
    );
    P(() => {
      l.value && (l.value.mode = e.active ? e.mode || j.SPORADIC : j.DISABLED);
    });
    const i = p(
      () => e.active,
      (o) => {
        l.value && (l.value.enabled = o);
      }
    );
    return F(() => {
      f(), v(), u(), i();
    }), (o, s) => null;
  }
}), Oe = /* @__PURE__ */ O({
  __name: "Outline",
  props: {
    outlinedObjects: {},
    blur: { type: Boolean },
    xRay: { type: Boolean },
    kernelSize: {},
    pulseSpeed: {},
    resolutionX: {},
    resolutionY: {},
    edgeStrength: {},
    patternScale: {},
    multisampling: {},
    blendFunction: {},
    patternTexture: {},
    resolutionScale: {},
    hiddenEdgeColor: {},
    visibleEdgeColor: {}
  },
  setup(e) {
    const a = e, { state: n } = A(), t = C(z), l = T(null), r = T(null), c = (u) => u !== void 0 ? R(u).getHex() : void 0, f = y(() => {
      const {
        blur: u,
        xRay: i,
        kernelSize: o,
        pulseSpeed: s,
        resolutionX: d,
        resolutionY: m,
        patternScale: g,
        edgeStrength: h,
        multisampling: B,
        blendFunction: x,
        patternTexture: Y,
        resolutionScale: K,
        hiddenEdgeColor: U,
        visibleEdgeColor: V
      } = a;
      return {
        blur: u,
        xRay: i,
        kernelSize: o,
        pulseSpeed: s,
        resolutionX: d,
        resolutionY: m,
        patternScale: g,
        edgeStrength: h,
        blendFunction: x,
        multisampling: B,
        patternTexture: Y,
        resolutionScale: K,
        hiddenEdgeColor: c(U),
        visibleEdgeColor: c(V)
      };
    }), v = P(() => {
      var u;
      n.camera && t && t.value && n.scene && (r.value = new G(n.scene, n.camera, f.value), l.value = new L(n.camera, r.value), (u = t.value) == null || u.addPass(l.value), v());
    });
    return p(
      [() => a.outlinedObjects, r],
      // whatchEffect is intentionally not used here as it would result in an endless loop
      () => {
        var u;
        (u = r.value) == null || u.selection.set(a.outlinedObjects || []);
      },
      {
        immediate: !0
      }
    ), P(() => {
      if (!r.value)
        return;
      const u = new G(), {
        blur: i,
        xRay: o,
        kernelSize: s,
        pulseSpeed: d,
        patternScale: m,
        edgeStrength: g,
        multisampling: h,
        hiddenEdgeColor: B,
        visibleEdgeColor: x
      } = f.value;
      r.value.blur = i !== void 0 ? i : u.blur, r.value.xRay = o !== void 0 ? o : u.xRay, r.value.pulseSpeed = d !== void 0 ? d : u.pulseSpeed, r.value.kernelSize = s !== void 0 ? s : u.kernelSize, r.value.edgeStrength = g !== void 0 ? g : u.edgeStrength, r.value.patternScale = m !== void 0 ? m : u.patternScale, r.value.multisampling = h !== void 0 ? h : u.multisampling, r.value.hiddenEdgeColor = B !== void 0 ? R(B) : u.hiddenEdgeColor, r.value.visibleEdgeColor = x !== void 0 ? R(x) : u.visibleEdgeColor, u.dispose();
    }), F(() => {
      var u, i, o, s;
      (u = r.value) == null || u.selection.clear(), l.value && ((i = t == null ? void 0 : t.value) == null || i.removePass(l.value)), (o = r.value) == null || o.dispose(), (s = l.value) == null || s.dispose();
    }), (u, i) => null;
  }
});
export {
  Be as Bloom,
  Ee as EffectComposer,
  xe as Glitch,
  Oe as Outline
};
